Attribute VB_Name = "DLLDef"
'-----------------------------------------------------------------------
'       aisa41.bas
'
'       AISA-P41 Win32 API.
'-----------------------------------------------------------------------

Option Explicit

' Errors

Global Const AISA41_SUCCESS = 0                ' Successfully proccessed
Global Const AISA41_ERR_SYSTEM = 1             ' Call GetLastError()
Global Const AISA41_ERR_NO_DEVICE = 2          ' No card
Global Const AISA41_ERR_IN_USE = 3             ' Device is in use
Global Const AISA41_ERR_INVALID_SLOT = 4       ' Invalid logical slot
Global Const AISA41_ERR_RESOURCE = 5           ' Resource exhaustion
Global Const AISA41_ERR_INVALID_PORT = 6       ' Invalid port
Global Const AISA41_ERR_INVALID_ARGUMENT = 7   ' Invalid port

' Direction

Global Const AISA41_DIR_A_OUTPUT = &H0
Global Const AISA41_DIR_A_INPUT = &H1
Global Const AISA41_DIR_B_OUTPUT = &H0
Global Const AISA41_DIR_B_INPUT = &H2
Global Const AISA41_DIR_C_OUTPUT = &H0
Global Const AISA41_DIR_C_INPUT = &H4
Global Const AISA41_DIR_D_OUTPUT = &H0
Global Const AISA41_DIR_D_INPUT = &H8
Global Const AISA41_DIR_E_OUTPUT = &H0
Global Const AISA41_DIR_E_INPUT = &H10
Global Const AISA41_DIR_F_OUTPUT = &H0
Global Const AISA41_DIR_F_INPUT = &H20
Global Const AISA41_DIR_G_OUTPUT = &H0
Global Const AISA41_DIR_G_INPUT = &H40
Global Const AISA41_DIR_H_OUTPUT = &H0
Global Const AISA41_DIR_H_INPUT = &H80

' Port numbers

Global Const AISA41_PORT_A = 0
Global Const AISA41_PORT_B = 1
Global Const AISA41_PORT_C = 2
Global Const AISA41_PORT_D = 3
Global Const AISA41_PORT_E = 4
Global Const AISA41_PORT_F = 5
Global Const AISA41_PORT_G = 6
Global Const AISA41_PORT_H = 7


' Miscsellaneous

Global Const AISA41_MAX_SLOTS = 16             ' Maximum number of slots

Global Const AISA41_SLOT_AUTO = &HFFFF

' Resource infomation structure

Global Const AISA41_MAX_MEM = 9
Global Const AISA41_MAX_IO = 20
Global Const AISA41_MAX_IRQ = 7
Global Const AISA41_MAX_DMA = 7

Type AISA41RESOURCE
    dwNumMemWindows As Long                         ' Not used
    dwMemBase(1 To AISA41_MAX_MEM) As Long          ' Not used
    dwMemLength(1 To AISA41_MAX_MEM) As Long        ' Not used
    dwMemAttrib(1 To AISA41_MAX_MEM) As Long        ' Not used
    dwNumIOPorts As Long                            ' Num IO ports
    dwIOPortBase(1 To AISA41_MAX_IO) As Long        ' I/O port base
    dwIOPortLength(1 To AISA41_MAX_IO) As Long      ' I/O port length
    dwNumIRQs As Long                               ' Num IRQ info
    dwIRQRegisters(1 To AISA41_MAX_IRQ) As Long     ' IRQ list
    dwIRQAttrib(1 To AISA41_MAX_IRQ) As Long        ' IRQ Attrib list
    dwNumDMAs As Long                               ' Not used
    dwDMALst(1 To AISA41_MAX_DMA) As Long           ' Not used
    dwDMAAttrib(1 To AISA41_MAX_DMA) As Long        ' Not used
    dwReserved1(1 To 3) As Long                     ' Not used
End Type

Declare Function Aisa41GetVersion Lib "aisa41" (lpdwDllVer As Long, lpdwDrvVer As Long) As Long
Declare Function Aisa41Create Lib "aisa41" (lpwLogSlot As Integer) As Long
Declare Function Aisa41Close Lib "aisa41" (ByVal wLogSlot As Integer) As Long
Declare Function Aisa41GetResource Lib "aisa41" (ByVal wLogSlot As Integer, lpres As AISA41RESOURCE) As Long
Declare Function Aisa41SetDirections Lib "aisa41" (ByVal wLogSlot As Integer, ByVal dwDirections As Long) As Long
Declare Function Aisa41InPort Lib "aisa41" (ByVal wLogSlot As Integer, ByVal dwLogPort As Long, lpbInValue As Byte) As Long
Declare Function Aisa41OutPort Lib "aisa41" (ByVal wLogSlot As Integer, ByVal dwLogPort As Long, ByVal bOutValue As Byte) As Long
Declare Function Aisa41GetLastError Lib "aisa41" (ByVal wLogSlot As Integer) As Long
