Attribute VB_Name = "Sample"
'*****************************************************************************
'* aisa41s.bas
'*
'* aISA-P41
'*
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'*
'* Date 1998/06/04
'*
'*  ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
'*
'*****************************************************************************
Option Explicit

Private Const szName = "aISA-P41"
Private Declare Function GetLastError Lib "kernel32" () As Long


Sub Main()

    Dim strbuf As String
    Dim dwDllVer As Long                ' DLL̃o[W
    Dim dwDrvVer As Long                ' Driver̃o[W
    Dim bResult As Boolean              ' 
    Dim wLogSlot As Integer             ' foCXi[
    Dim dwDirections As Long            ' fBNV
    Dim InValue As Byte                 ' o̓f[^
    Dim OutValue As Byte
    Dim ri As AISA41RESOURCE            ' \[X

'---------------------------------------------------------------------------
    ' aisa41.dll ̎gp錾
    If Aisa41wDllOpen() = False Then
        ErrorMessage (AISA41_SLOT_AUTO)
        Exit Sub                ' aisa41.dll ̃[hɎs܂B
    End If

'---------------------------------------------------------------------------
    ' o[Wԍ\
    If Aisa41wGetVersion(dwDllVer, dwDrvVer) = False Then ' aISA-P41DLL,Driver̃o[Wԍ擾
        ErrorMessage (AISA41_SLOT_AUTO)
        Exit Sub
    End If

    strbuf = "GetVersion" + Chr(10) + _
             "DLL Version: &H" + Hex(dwDllVer) + Chr(10) + _
             "Drv Version: &H" + Hex(dwDrvVer)
    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' aISA-P41̎gp錾
    wLogSlot = AISA41_SLOT_AUTO     ' gp̃foCXT܂B
    bResult = Aisa41wCreate(wLogSlot)

    If bResult = False Then         ' foCX܂B
        ErrorMessage (AISA41_SLOT_AUTO)
        Exit Sub
    End If

    strbuf = "aISA-P41 Created" + Chr(10) + Chr(10) + _
          "LogSlot: " + Str(wLogSlot)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' \[X擾
    If Aisa41wGetResource(wLogSlot, ri) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "Board Name: " + szName + Chr(10) + _
             "NumPorts: " + Str(ri.dwIOPortLength(1)) + Chr(10) + _
             "IO Address: &H" + Hex(ri.dwIOPortBase(1)) + _
             "-&H" + Hex(ri.dwIOPortBase(1) + ri.dwIOPortLength(1) - 1)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' A Port ̃fBNVo͂ɐݒ

    ' A Port ̃rbgo͂ɕύX܂B
    dwDirections = (Not AISA41_DIR_A_INPUT) And dwDirections

    ' fBNVZbg
    If Aisa41wSetDirections(wLogSlot, dwDirections) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ResultMessage ("Port A ̃fBNVo͂ɕύX")

'---------------------------------------------------------------------------
    ' Port AɔCӂ̃f[^o
    ' &HAA -> 10101010
    OutValue = &HAA

    If Aisa41wOutPort(wLogSlot, AISA41_PORT_A, OutValue) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "Port A փf[^o" + Chr(10) + _
             "Port A Out Data: &H" + Hex(OutValue)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' A Port ̃fBNV͂ɐݒ

    ' A Port ̃rbg͂ɕύX܂B
    dwDirections = AISA41_DIR_A_INPUT Or dwDirections

    ' fBNVZbg
    If Aisa41wSetDirections(wLogSlot, dwDirections) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ResultMessage ("Port A ̃fBNV͂ɕύX")

'---------------------------------------------------------------------------
    ' Port A f[^ǂݍ
    InValue = &H0

    If Aisa41wInPort(wLogSlot, AISA41_PORT_A, InValue) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "Port A f[^" + Chr(10) + _
             "Port A In Data: &H" + Hex(InValue)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' aISA-P41̎gpJ
    If Aisa41wClose(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ResultMessage ("aISA-P41 Closed")

'---------------------------------------------------------------------------
    ' aisa41.dll̎gpJ
    If Aisa41wDllClose() = False Then
        MsgBox "DLL ̃A[hɎs܂B", vbOKOnly + vbCritical
        Exit Sub        ' aisa41.dll ̃A[hɎs܂B
    End If

End Sub

'---------------------------------------------------------------------------
    ' ʂ\
Private Sub ResultMessage(lpszbuf As String)

    MsgBox lpszbuf, vbOKOnly + vbInformation

End Sub

'---------------------------------------------------------------------------
    ' G[bZ[W\
Private Sub ErrorMessage(wLogSlot As Integer)

    Dim dwRes As Long
    Dim szbuf As String

    dwRes = Aisa41wGetLastError(wLogSlot)

    Select Case dwRes
    Case AISA41_ERR_SYSTEM
        szbuf = "System error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(GetLastError())

    Case AISA41_ERR_WRAPDLL
        szbuf = "DLL Load error"

    Case Else                           ' ̑̒l̏ꍇB
        szbuf = "aISA-P41 error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(dwRes)
    End Select

    MsgBox szbuf, vbOKOnly + vbCritical

End Sub
