Attribute VB_Name = "Wrapper"
'*****************************************************************************
'* aisa41w.bas
'*
'* aISA-P41
'*
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'*
'* Date 1998/05/28
'*
'*****************************************************************************
Option Explicit

Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const AISA41_DLL_NAME = "aisa41.dll"  ' DLLt@C
Global Const AISA41_ERR_WRAPDLL = -1        ' bp[֐G[

Dim hDLL As Long                'DLLւ̃nh

'*****************************************************************************
'* @\     aisa41.dll[h
'*      Ȃ
'* ߂l   True  --- 
'*          False --- s
'*****************************************************************************
Function Aisa41wDllOpen() As Boolean

    Aisa41wDllOpen = False
    
    If hDLL <> 0 Then Exit Function
    hDLL = LoadLibrary(AISA41_DLL_NAME)
    
    If hDLL = 0 Then Exit Function
    
    If Aisa41wGetDllExportFunc() = False Then
        Aisa41wDllClose     ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
        Exit Function
    End If
    
    Aisa41wDllOpen = True

End Function

'*****************************************************************************
'* @\     aisa41.dllA[h
'*      Ȃ
'* ߂l   True  --- 
'*          False --- s
'*****************************************************************************
Function Aisa41wDllClose() As Boolean
    
    If hDLL = 0 Then
        Aisa41wDllClose = True
        Exit Function
    End If
    
    If FreeLibrary(hDLL) <> 0 Then
        hDLL = 0
        Aisa41wDllClose = True
        Exit Function
    End If
    
    Aisa41wDllClose = False

End Function

'*****************************************************************************
'* @\     aISA-P41 DLL,Driver̃o[Wԍ擾
'*      pdwDllVer --- DLLo[Wԍi[
'*          pdwDrvVer --- Drivero[Wԍi[
'* ߂l   True          --- 
'*          False         --- s
'*****************************************************************************
Function Aisa41wGetVersion(pdwDllVer As Long, pdwDrvVer As Long) As Boolean
    
    If hDLL = 0 Then
        Aisa41wGetVersion = 0
        Exit Function
    End If
    
    If Aisa41GetVersion(pdwDllVer, pdwDrvVer) <> 0 Then
        Aisa41wGetVersion = True
    Else
        Aisa41wGetVersion = False
    End If

End Function

'*****************************************************************************
'* @\     aISA-P41̔Cӂ̃foCX̎gp錾
'*      pwLogSlot --- gpfoCXi[AhX
'* ߂l   True      --- 
'*          False     --- s
'*****************************************************************************
Function Aisa41wCreate(pwLogSlot As Integer) As Boolean
    
    If hDLL = 0 Then
        Aisa41wCreate = False
        Exit Function
    End If
    
    If Aisa41Create(pwLogSlot) <> 0 Then
        Aisa41wCreate = True
    Else
        Aisa41wCreate = False
    End If

End Function

'*****************************************************************************
'* @\     aISA-P41̔Cӂ̃foCX̎gpJ
'*      wLogSlot --- gpfoCX
'* ߂l   True     --- 
'*          False    --- s
'*****************************************************************************
Function Aisa41wClose(wLogSlot As Integer) As Boolean
    
    If hDLL = 0 Then
        Aisa41wClose = False
        Exit Function
    End If
    
    If Aisa41Close(wLogSlot) <> 0 Then
        Aisa41wClose = True
    Else
        Aisa41wClose = False
    End If

End Function

'*****************************************************************************
'* @\     wfoCX̃\[X擾
'*      wLogSlot --- ׂfoCX
'*          pResInfo --- \[Xi[\̂̃AhX
'* ߂l   True     --- 
'*          False    --- s
'*****************************************************************************
Function Aisa41wGetResource(wLogSlot As Integer, pResInfo As AISA41RESOURCE) As Boolean
    
    If hDLL = 0 Then
        Aisa41wGetResource = False
        Exit Function
    End If
    
    If Aisa41GetResource(wLogSlot, pResInfo) <> 0 Then
        Aisa41wGetResource = True
    Else
        Aisa41wGetResource = False
    End If

End Function

'*****************************************************************************
'*      fBNVZbg
'*      wLogSlot     --- ZbgfoCX
'*          dwDirections --- Zbge
'* ߂l   True         --- 
'*          False        --- s
'*****************************************************************************
Function Aisa41wSetDirections(wLogSlot As Integer, dwDirections As Long) As Boolean
    
    If hDLL = 0 Then
        Aisa41wSetDirections = False
        Exit Function
    End If

    If Aisa41SetDirections(wLogSlot, dwDirections) <> 0 Then
        Aisa41wSetDirections = True
    Else
        Aisa41wSetDirections = False
    End If

End Function

'*****************************************************************************
'* @\     Cӂ̃|[gf[^
'*      wLogSlot  --- ͂foCX
'*          dwPort    --- ͂|[g
'*          pbInValue --- ̓f[^i[
'* ߂l   True      --- 
'*          False     --- s
'*****************************************************************************
Function Aisa41wInPort(wLogSlot As Integer, dwPort As Long, pbInValue As Byte) As Boolean
    
    If hDLL = 0 Then
        Aisa41wInPort = False
        Exit Function
    End If
    
    If Aisa41InPort(wLogSlot, dwPort, pbInValue) <> 0 Then
        Aisa41wInPort = True
    Else
        Aisa41wInPort = False
    End If

End Function

'*****************************************************************************
'* @\     Cӂ̃|[gփf[^o
'*      wLogSlot  --- o͂foCX
'*          dwPort    --- o͂|[g
'*          bOutValue --- o͂f[^
'* ߂l   True      --- 
'*          False     --- s
'*****************************************************************************
Function Aisa41wOutPort(wLogSlot As Integer, dwPort As Long, bOutValue As Byte) As Boolean
    
    If hDLL = 0 Then
        Aisa41wOutPort = False
        Exit Function
    End If
    
    If Aisa41OutPort(wLogSlot, dwPort, bOutValue) <> 0 Then
        Aisa41wOutPort = True
    Else
        Aisa41wOutPort = False
    End If

End Function

'*****************************************************************************
'* @\      aISA-P41̃G[R[h𓾂
'*       wLogSlot --- G[foCX
'* ߂l             --- G[R[h
'*****************************************************************************
Function Aisa41wGetLastError(wLogSlot As Integer) As Long
    
    If hDLL = 0 Then
        Aisa41wGetLastError = AISA41_ERR_WRAPDLL
        Exit Function
    End If
    
    Aisa41wGetLastError = Aisa41GetLastError(wLogSlot)

End Function

'*****************************************************************************
'* @\     DLLGNX|[g֐L̊mF
'*      Ȃ
'* ߂l   True  --- 
'*          False --- s
'*****************************************************************************
Private Function Aisa41wGetDllExportFunc() As Boolean
    
    Dim pFunc As Long
    
    Aisa41wGetDllExportFunc = False
    
    ' Aisa41GetVersion ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa41GetVersion")
    If pFunc = 0 Then Exit Function
          
    ' Aisa41Create ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa41Create")
    If pFunc = 0 Then Exit Function
          
    ' Aisa41Close ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa41Close")
    If pFunc = 0 Then Exit Function

    ' Aisa41GetResource ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa41GetResource")
    If pFunc = 0 Then Exit Function

    ' Aisa41SetDirections ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa41SetDirections")
    If pFunc = 0 Then Exit Function

    ' Aisa41InPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa41InPort")
    If pFunc = 0 Then Exit Function

    ' Aisa41OutPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa41OutPort")
    If pFunc = 0 Then Exit Function

    ' Aisa41GetLastError ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa41GetLastError")
    If pFunc = 0 Then Exit Function

    Aisa41wGetDllExportFunc = True  ' SĂ DLL GNX|[g֐݂̑mF

End Function
