#ifndef _Aisap41_H_
#define _Aisap41_H_

#ifdef __cplusplus
extern "C" {
#endif

#define AISA41_MAX_SLOTS	16
#define	AISA41_SLOT_AUTO	((WORD) ~0U)

//-------------------- Port Define ----------------------
#define	AISA41_PORT_A		0
#define	AISA41_PORT_B		1
#define	AISA41_PORT_C		2
#define	AISA41_PORT_D		3
#define	AISA41_PORT_E		4
#define	AISA41_PORT_F		5
#define	AISA41_PORT_G		6
#define	AISA41_PORT_H		7

//-------------------- Direction ------------------------
#define	AISA41_DIR_A_OUTPUT	(0 << 0)
#define	AISA41_DIR_A_INPUT	(1 << 0)
#define	AISA41_DIR_B_OUTPUT	(0 << 1)
#define	AISA41_DIR_B_INPUT	(1 << 1)
#define	AISA41_DIR_C_OUTPUT	(0 << 2)
#define	AISA41_DIR_C_INPUT	(1 << 2)
#define	AISA41_DIR_D_OUTPUT	(0 << 3)
#define	AISA41_DIR_D_INPUT	(1 << 3)
#define	AISA41_DIR_E_OUTPUT	(0 << 4)
#define	AISA41_DIR_E_INPUT	(1 << 4)
#define	AISA41_DIR_F_OUTPUT	(0 << 5)
#define	AISA41_DIR_F_INPUT	(1 << 5)
#define	AISA41_DIR_G_OUTPUT	(0 << 6)
#define	AISA41_DIR_G_INPUT	(1 << 6)
#define	AISA41_DIR_H_OUTPUT	(0 << 7)
#define	AISA41_DIR_H_INPUT	(1 << 7)

// G[R[h
#define AISA41_SUCCESS				0	// ُȂ
#define AISA41_ERR_SYSTEM			1	// GetLastError sĂ
#define AISA41_ERR_NO_DEVICE		2	// gp\ȃfoCXȂ
#define AISA41_ERR_IN_USE			3	// w肳ꂽXbg͎gp
#define AISA41_ERR_INVALID_SLOT		4	// Ș_Xbgԍ
#define AISA41_ERR_RESOURCE			5	// \[XG[
#define AISA41_ERR_INVALID_PORT		6	// ȃ|[gԍ
#define AISA41_ERR_INVALID_ARGUMENT	7	// Ȉ

#define AISA41_MAX_MEM		9
#define AISA41_MAX_IO		20
#define AISA41_MAX_IRQ		7
#define AISA41_MAX_DMA		7

//======================================================================
// \[X\
//======================================================================
typedef struct {
	DWORD	dwNumMemWindows;				   // EChE	gp
	DWORD	dwMemBase		[AISA41_MAX_MEM];  // MWx[XAhX		gp
	DWORD	dwMemLength		[AISA41_MAX_MEM];  // MW					gp
	DWORD	dwMemAttrib		[AISA41_MAX_MEM];  // MW				gp
	DWORD	dwNumIOPorts;					   // I/O|[g
	DWORD	dwIOPortBase	[AISA41_MAX_IO];   // I/O|[gx[XAhX
	DWORD	dwIOPortLength	[AISA41_MAX_IO];   // I/O|[g
	DWORD	dwNumIRQs;						   // IRQ					gp
	DWORD	dwIRQRegisters	[AISA41_MAX_IRQ];  // IRQXg				gp
	DWORD	dwIRQAttrib		[AISA41_MAX_IRQ];  // IRQXg			gp
	DWORD	dwNumDMAs;						   // DMA`l			gp
	DWORD	dwDMALst		[AISA41_MAX_DMA];  // DMA`lXg		gp
	DWORD	dwDMAAttrib		[AISA41_MAX_DMA];  // DMA`lXg	gp
	DWORD	dwReserved1		[3];			   // \					gp
} AISA41RESOURCE;

typedef		AISA41RESOURCE *PAISA41R;
typedef		AISA41RESOURCE FAR *LPAISA41R;

//-- ȉAPI --
//======================================================================
// DLL  Driver ̃o[W擾
//======================================================================
BOOL WINAPI Aisa41GetVersion(
	PDWORD		pdwDllVer,		// DLL Version
	PDWORD		pdwDrvVer );	// Driver Version

//======================================================================
// foCXgp錾
//======================================================================
BOOL WINAPI Aisa41Create(
	PWORD pwLogSlot );			// Xbgԍ( 0`15 or SLOT_AUTO )

//======================================================================
// foCXJ
//======================================================================
BOOL WINAPI Aisa41Close(
	WORD wLogSlot );			// Xbgԍ( 0`15 )

//======================================================================
// \[X擾
//======================================================================
BOOL WINAPI Aisa41GetResource(
	WORD	wLogSlot,			// Slot
	AISA41RESOURCE *pRes );		// \[X\̂̃|C^

//======================================================================
// C|[g
//======================================================================
BOOL WINAPI Aisa41InPort(
	WORD	wLogSlot,			// Slot
	DWORD	dwPort,				// |[gԍ( 0 - 7 )
	PBYTE	pbValue );			// l

//======================================================================
// AEg|[g
//======================================================================
BOOL WINAPI Aisa41OutPort(
	WORD	wLogSlot,			// Slot
	DWORD	dwPort,				// |[gԍ( 0 - 7 )
	BYTE	bValue );			// l

//======================================================================
// 
//======================================================================
BOOL WINAPI Aisa41SetDirections(
	WORD	wLogSlot,			// Slot
	DWORD	dwDirections );		// |[gf[^

//======================================================================
// Ōw肳ꂽXbgŔsꂽG[R[ho
//======================================================================
DWORD WINAPI Aisa41GetLastError(
	WORD	wLogSlot );			// Slot

#ifdef __cplusplus
}
#endif
#endif
