/*****************************************************************************
 *	aisa41w.c
 *
 *	aISA-P41
 *
 *	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
 *
 *	Date 1998/05/20
 *
 *****************************************************************************/
#include <windows.h>
#include <tchar.h>
#include "aisa41w.h"	// aISA-P41

//---------- X^eBbN֐ & X^eBbNϐ(萔)	----------------------
static BOOL Aisa41wGetDllExportFunc();
static HMODULE hDLL = NULL;

// DLL GNX|[g֐AhX̊i[pϐ
static FARPROC pAisa41GetVersion;
static FARPROC pAisa41Create;
static FARPROC pAisa41Close;
static FARPROC pAisa41GetResource;
static FARPROC pAisa41InPort;
static FARPROC pAisa41OutPort;
static FARPROC pAisa41SetDirections;
static FARPROC pAisa41GetLastError;

BOOL Aisa41wDllOpen ( void )
/*****************************************************************************
 * @\  aisa41.dll[h
 * 	 Ȃ
 * ߒl	 TRUE  --- 
 *		 FALSE --- s
 *****************************************************************************/
{
	if (hDLL != NULL) {
		return FALSE;
	}
	hDLL = (HMODULE)LoadLibrary(AISA41_DLL_NAME);
	if (hDLL == NULL) {
		return FALSE;
	}
	if (Aisa41wGetDllExportFunc() == FALSE) {
		// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Aisa41wDllClose();
		return FALSE;
	}
	return TRUE;
}

BOOL Aisa41wDllClose ( void )
/*****************************************************************************
 * @\  aisa41.dllA[h
 * 	 Ȃ
 * ߒl	 TRUE  --- 
 *		 FALSE --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	if (FreeLibrary(hDLL) == TRUE) {
		hDLL = NULL;
		return TRUE;
	}
	return FALSE;
}

BOOL Aisa41wGetVersion ( PDWORD pdwDllVer, PDWORD pdwDrvVer )
/*****************************************************************************
 * @\  aISA-P41DLL,Driver̃o[Wԍ擾
 * 	 pdwDllVer --- DLLo[Wԍi[AhX
 *		 pdwDrvVer --- Drivero[Wԍi[AhX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa41GetVersion)(pdwDllVer, pdwDrvVer);
}

BOOL Aisa41wCreate ( PWORD pwLogSlot )
/*****************************************************************************
 * @\  aISA-P41̔Cӂ̃foCX̎gp錾
 * 	 pwLogSlot	--- gpfoCXi[AhX
 * ߒl	 TRUE		--- 
 *		 FALSE		--- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa41Create)(pwLogSlot);
}

BOOL Aisa41wClose ( WORD wLogSlot )
/*****************************************************************************
 * @\  aISA-P41̔Cӂ̃foCX̎gpJ
 * 	 wLogSlot  --- gpfoCX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa41Close)(wLogSlot);
}

BOOL Aisa41wGetResource ( WORD wLogSlot, PAISA41R pResInfo )
/*****************************************************************************
 * @\  wfoCX̃\[X擾
 * 	 wLogSlot --- ׂfoCX
 *		 pResInfo --- \[Xi[\̂̃AhX
 * ߒl	 TRUE	  --- 
 *		 FALSE	  --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa41GetResource)(wLogSlot, pResInfo);
}

BOOL Aisa41wInPort ( WORD wLogSlot, DWORD dwPort, PBYTE pbInValue )
/*****************************************************************************
 * @\  Cӂ̃|[gf[^
 * 	 wLogSlot  --- ͂foCX
 *		 dwPort	   --- ͂|[g
 *		 pbInValue --- ̓f[^i[AhX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa41InPort)(wLogSlot, dwPort, pbInValue);
}

BOOL Aisa41wOutPort ( WORD wLogSlot, DWORD dwPort, BYTE bOutValue )
/*****************************************************************************
 * @\  Cӂ̃|[gփf[^o
 * 	 wLogSlot  --- o͂foCX
 *		 dwPort	   --- o͂|[g
 *		 bOutValue --- o̓f[^
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa41OutPort)(wLogSlot, dwPort, bOutValue);
}

BOOL Aisa41wSetDirections ( WORD wLogSlot, DWORD dwDirections )
/*****************************************************************************
 * @\  |[g̕
 * 	 wLogSlot	  --- o͂foCX
 *		 dwDirections --- f[^
 * ߒl	 TRUE		  --- 
 *		 FALSE		  --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa41SetDirections)(wLogSlot, dwDirections);
}

DWORD Aisa41wGetLastError ( WORD wLogSlot )
/*****************************************************************************
 * @\  aISA-P41̃G[R[h
 * 	 wLogSlot  --- G[foCX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return AISA41_ERR_WRAPDLL;
	}
	return (*pAisa41GetLastError)(wLogSlot);
}

static BOOL Aisa41wGetDllExportFunc ( void )
/*---------------------------------------------------------------------------
 * 	 DLLGNX|[g֐AhX̎擾
 * 	 Ȃ
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *---------------------------------------------------------------------------*/
{
	// Aisa41GetVersion ̃AhX擾
	pAisa41GetVersion = GetProcAddress(hDLL, _T("Aisa41GetVersion"));
	if (pAisa41GetVersion == NULL) {
		return FALSE;
	}

	// Aisa41Create ̃AhX擾
	pAisa41Create = GetProcAddress(hDLL, _T("Aisa41Create"));
	if (pAisa41Create == NULL) {
		return FALSE;
	}

	// Aisa41Close ̃AhX擾
	pAisa41Close = GetProcAddress(hDLL, _T("Aisa41Close"));
	if (pAisa41Close == NULL) {
		return FALSE;
	}

	// Aisa41GetResource ̃AhX擾
	pAisa41GetResource = GetProcAddress(hDLL, _T("Aisa41GetResource"));
	if (pAisa41GetResource == NULL) {
		return FALSE;
	}

	// Aisa41InPort ̃AhX擾
	pAisa41InPort = GetProcAddress(hDLL, _T("Aisa41InPort"));
	if (pAisa41InPort == NULL) {
		return FALSE;
	}

	// Aisa41OutPort ̃AhX擾
	pAisa41OutPort = GetProcAddress(hDLL, _T("Aisa41OutPort"));
	if (pAisa41OutPort == NULL) {
		return FALSE;
	}

	// Aisa41SetDirectons ̃AhX擾
	pAisa41SetDirections = GetProcAddress(hDLL, _T("Aisa41SetDirections"));
	if (pAisa41SetDirections == NULL) {
		return FALSE;
	}

	// Aisa41GetLastError ̃AhX擾
	pAisa41GetLastError = GetProcAddress(hDLL, _T("Aisa41GetLastError"));
	if (pAisa41GetLastError == NULL) {
		return FALSE;
	}
	return TRUE;	// SĂ DLL GNX|[g֐AhX擾
}
